import Editor from 'tui-editor';
import { Injectable, Directive, Input, Output, EventEmitter, ElementRef, HostBinding, Component, NgModule, ɵɵdefineInjectable } from '@angular/core';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-wysiwyg-md-editor.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxWysiwygMdEditorService {
    constructor() { }
}
NgxWysiwygMdEditorService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgxWysiwygMdEditorService.ctorParameters = () => [];
/** @nocollapse */ NgxWysiwygMdEditorService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxWysiwygMdEditorService_Factory() { return new NgxWysiwygMdEditorService(); }, token: NgxWysiwygMdEditorService, providedIn: "root" });

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-wysiwyg-md-editor.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxWysiwygMdEditorComponent {
    constructor() { }
    /**
     * @return {?}
     */
    ngOnInit() {
    }
}
NgxWysiwygMdEditorComponent.decorators = [
    { type: Component, args: [{
                selector: 'lib-ngx-wysiwyg-md-editor',
                template: `
    <p>
      ngx-wysiwyg-md-editor works!
    </p>
  `
            }] }
];
/** @nocollapse */
NgxWysiwygMdEditorComponent.ctorParameters = () => [];

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-wysiwyg-md-editor.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class WysiwygMdEditorDirective {
    /**
     * @param {?} element
     */
    constructor(element) {
        this.element = element;
        this.valueChange = new EventEmitter();
        this.display = 'block';
        this.defaults = {
            el: this.element.nativeElement,
            initialValue: '',
            initialEditType: 'wysiwyg',
            previewStyle: 'vertical',
            height: '300px'
        };
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        /** @type {?} */
        const options = Object.assign(this.defaults, {
            initialValue: this.initialValue || this.defaults.initialValue,
            initialEditType: this.editType || this.defaults.initialEditType,
            height: this.height || this.defaults.height,
            previewStyle: this.previewStyle || this.defaults.previewStyle,
        });
        this.editor = new Editor(options);
        this.editor.on('change', (/**
         * @return {?}
         */
        () => {
            this.valueChange.emit(this.editor.getValue());
        }));
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.editor.off('change');
        this.editor.remove();
    }
}
WysiwygMdEditorDirective.decorators = [
    { type: Directive, args: [{
                selector: 'ngxWysiwygMdEditor, [ngxWysiwygMdEditor]'
            },] }
];
/** @nocollapse */
WysiwygMdEditorDirective.ctorParameters = () => [
    { type: ElementRef }
];
WysiwygMdEditorDirective.propDecorators = {
    initialValue: [{ type: Input }],
    editType: [{ type: Input }],
    height: [{ type: Input }],
    previewStyle: [{ type: Input }],
    valueChange: [{ type: Output }],
    display: [{ type: HostBinding, args: ['style.display',] }]
};

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ngx-wysiwyg-md-editor.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxWysiwygMdEditorModule {
}
NgxWysiwygMdEditorModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgxWysiwygMdEditorComponent, WysiwygMdEditorDirective],
                imports: [],
                exports: [NgxWysiwygMdEditorComponent, WysiwygMdEditorDirective]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngx-wysiwyg-markdown-editor.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxWysiwygMdEditorService, NgxWysiwygMdEditorComponent, WysiwygMdEditorDirective, NgxWysiwygMdEditorModule };

//# sourceMappingURL=ngx-wysiwyg-markdown-editor.js.map